// Copyright (C) 2002-2008 - DIGITEO - Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function axes_ticks(step,sub_grid,varargin)
  a=gca();
  [lhs,rhs]=argn();
  if rhs==0 then a.auto_ticks="on"; return; end
  if rhs>2 then error("The function ""axes_ticks"" must have at most two arguments."); end
  if type(step)<>1|find(size(step)==1)==[]|size(step,"*")>2 then
    error("The first argument of the function ""axes_ticks"" must be a number or a vector of numbers of dimension 2.");
  end
  if size(step,"*")==1&step<=0 then
    error("The first argument of the function ""axes_ticks"" must be a positive number.")
  end
  if size(step,"*")==2&max(step)<=0 then
    error("The first argument of the function ""axes_ticks"" must be a vector of positive numbers.")
  end
  if rhs==1 then
    sub_grid=max(a.sub_ticks,[0,0]);
  else
    if type(sub_grid)<>1|find(size(sub_grid)==1)==[]|size(sub_grid,"*")>2 then
      error("The second argument of the function ""axes_ticks"" must be a number or a vector of numbers of dimension 2.");
    end
    if size(sub_grid,"*")==1&(int(sub_grid)-sub_grid<>0|sub_grid<0) then
      error("The second argument of the function ""axes_ticks"" must be a positive integer or zero.")
    end
    if size(sub_grid,"*")==2 then
      if int(sub_grid(1))-sub_grid(1)<>0|int(sub_grid(2))-sub_grid(2)<>0|sub_grid(1)<0|sub_grid(2)<0 then
      error("The second argument of the function ""axes_ticks"" must be a vector of two positive numbers or zeros.")
      end
    end
  end
  if size(step,"*")==1 then 
    step=[step,step];   
  end
  if size(sub_grid,"*")==1 then
    sub_grid=[sub_grid,sub_grid]; 
  end
  x0=a.x_ticks.locations(1); x1=a.data_bounds(2,1);
  y0=a.y_ticks.locations(1); y1=a.data_bounds(2,2);
  x=x0:step(1):x1; y=y0:step(2):y1;
  a.x_ticks=tlist(["ticks","locations","labels"],x,string(x));
  a.y_ticks=tlist(["ticks","locations","labels"],y,string(y));
  a.sub_ticks=sub_grid;
endfunction

