// Copyright (C) 2002-2009 - DIGITEO - Michael Baudin et Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function r=combination(n,p,varargin)
  [lhs,rhs]=argn();
  if rhs<>2 then error("The function ""combination"" must have two arguments."); end
  if type(n)<>1|size(n,"*")<>1|int(n)-n<>0|n<0|type(p)<>1|size(p,"*")<>1|int(p)-p<>0|p<0 then 
    error("The arguments of the function ""combination"" must be positive integers or zero.");
  end
  if p>n then 
    error("The second argument of the function ""combination"" must be less than or equal to the first.");
  end
  r=round(exp(gammaln(n+1)-gammaln(p+1)-gammaln(n-p+1)));
endfunction