// Copyright (C) 2011 - SCILAB ENTERPRISES - Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function r=geometric_prob(n,p,varargin)
    [lhs,rhs]=argn();
    if rhs<>2&rhs<>3 then error("The function ""geometric_prob"" must have two or three arguments."); end 
    if type(n)<>1|size(n,"*")<>1|int(n)-n<>0|n<1 then
        error("The first argument of the function ""geometric_prob"" must be a positive integer.");
    end
    if type(p)<>1|size(p,"*")<>1|p<0|p>1 then
        error("The second argument of the function ""geometric_prob"" must be a number between 0 and 1.");
    end
    r=[(1-p)^n,cumprod([p,(1-p)*ones(1,n-1)])];
    if rhs==3 then
        k=varargin(1);
        if type(k)<>1|size(k,"*")<>1|int(k)-k<>0|k<0|k>n then
            error("The third argument of the function ""geometric_prob"" must be an integer between 0 and the first argument.");
        end
        r=r(k+1);
    end
endfunction