// Copyright (C) 2002-2009 - DIGITEO - Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function histogram(a,n,the_color,varargin)
  [lhs,rhs]=argn();
  if rhs>3 then error("The function ""histogram"" must have at most three arguments."); end
  if rhs==2 then
    the_color="b";
  end
  if rhs<2 then error("The function ""histogram"" must have at least two arguments."); end
  if type(a)<>1|find(size(a)==1)==[]|type(n)<>1|find(size(n)==1)==[] then
    error("The second argument of the ""histogram"" must be a vector of numbers.");
  end
  if size(a,"*")<>size(n,"*")+1 then
    error("The first argument of the function ""histograme"" must have dimension one more than the second argument.");
  end
  if min(n)<0 then
    error("The second argument of the function ""histogram"" must be a vector of positive numbers or zeros.");
  end
  if sum(n)<%eps then
    error("The second argument of the function ""histogram"" must not be the null vector.");
  end
  vcol=["r","g","b","c","m","y","k","w"]; icol=find(the_color==vcol);
  if icol==[] then
    error("The third argument of the function ""histogram"" must be a color.");
  end
  vcol2=["red","green","blue","cyan","magenta","yellow","black","white"];
  the_color=color(vcol2(icol));  
  nrect=size(a,"*")-1;
  for i=1:nrect
    if a(i)>=a(i+1) then
      error("The first argument of the function ""histogram"" must be a vector of increasing numbers.");
    end
  end
  xv=[]; yv=[];
  for i=1:nrect
    xv=[xv,a(i),a(i),a(i+1),a(i+1)];
    h(i)=n(i)/(a(i+1)-a(i));
    yv=[yv,0,h(i),h(i),0];
  end
  drawlater();
  plot(a(1),0); plot(a($),max(h));
  xpoly(xv,yv);
  hrect=gce(); hrect.foreground=the_color;
  axes=gca(); axes.axes_visible=["on","off","on"];
  drawnow();
endfunction