// Copyright (C) 2002-2008 - DIGITEO - Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function r=regression_y_on_x(x,y,varargin)
  [lhs,rhs]=argn();
  if rhs<>2 then error("The function ""regression_y_on_x"" must have two arguments."); end
  if type(x)<>1|find(size(x)==1)==[]|type(y)<>1|find(size(y)==1)==[] then
    error("The arguments of the function ""regression_y_on_x"" must be vectors of numbers.");
  end
  if size(x,"*")<>size(y,"*") then
    error("The arguments of the function ""regression_y_on_x"" must be vectors of the same .");
  end
  if abs(min(x)-max(x))<%eps then
    error("The first argument of the function ""regression_y_on_x"" must not have all its components the same.");
  end
  n=size(x,"*");
  xbar=sum(x)/n;
  ybar=sum(y)/n;
  covariance=sum(x.*y)/n-xbar*ybar;
  varx=sum(x.*x)/n-xbar*xbar;
  a=covariance/varx; b=ybar-a*xbar;
  r=[a,b];
endfunction

