// Copyright (C) 2002-2008 - DIGITEO - Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function r=weighted_deciles(x,n)
  [lhs,rhs]=argn();
  if rhs<>2 then error("The function ""weighted_deciles"" must have two arguments."); end
  if type(x)<>1|find(size(x)==1)==[]|type(n)<>1|find(size(n)==1)==[] then
    error("The arguments of the function ""weighted_deciles"" must be vectors of numbers.");
  end
  if size(x,"*")<>size(n,"*") then
    error("The arguments of the function ""weighted_deciles"" must be vectors of the same dimension.");
  end
  if min(n)<0 then
    error("The second argument of the function ""weighted_deciles"" must be a vector of positive numbers or zeros.");
  end
  if sum(n)<%eps then
    error("The second argument of the function ""weighted_deciles"" must not be the null vector.");
  end
  [x,k]=gsort(x,"g","i"); n=n(k);
  n=cumsum(n); ntotal=n($);
  i=ceil(ntotal/10); f=find(n<i); iq1=f($)+1;
  i=ceil(9*ntotal/10); f=find(n<i); iq3=f($)+1;
  r=[x(iq1),x(iq3)];
endfunction