// Copyright (C) 2002-2008 - DIGITEO - Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function r=weighted_mean(x,n,varargin)
  [lhs,rhs]=argn();
  if rhs<>2 then error("The function ""weighted_mean"" must have two arguments."); end
  if type(x)<>1|find(size(x)==1)==[]|type(n)<>1|find(size(n)==1)==[] then
    error("The arguments of the function ""weighted_mean"" must be vectors of numbers.");
  end
  if size(x,"*")<>size(n,"*") then
    error("The arguments of the function ""weighted_mean"" must be vectors of the same dimension.");
  end
  if min(n)<0 then
    error("The second argument of the function ""weighted_average"" must be a vector of numbers that are positive or zero.");
  end
  if sum(n)<%eps then
    error("The second argument of the function ""weighted_average"" must not be the null vector.");
  end
  r=(x*n')/sum(n);
endfunction