// Copyright (C) 2002-2008 - DIGITEO - Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function r=weighted_median(x,n,varargin)
  [lhs,rhs]=argn();
  if rhs<>2 then error("The function ""weighted_median"" must have two arguments."); end
  if type(x)<>1|find(size(x)==1)==[]|type(n)<>1|find(size(n)==1)==[] then
    error("The arguments of the function ""weighted_median"" must be vectors of numbers.");
  end
  if size(x,"*")<>size(n,"*") then
    error("The arguments of the function ""weighted_median"" must be vectors of the same dimension.");
  end
  if min(n)<0 then
    error("The second argument of the function ""weighted_median"" must be a vector of positive numbers or zeros.");
  end
  if sum(n)<%eps then
    error("The second argument of the function ""weighted_median"" must be the null vector.");
  end
  [x,k]=gsort(x,"g","i"); n=n(k);
  n=cumsum(n); nmiddle=n($)/2;
  if int(nmiddle)-nmiddle<>0 then
    nmiddle=ceil(nmiddle); f=find(n<nmiddle); im=f($)+1; r=x(im);
  else
    f=find(n<nmiddle); im1=f($)+1;
    f=find(n<nmiddle+1); im2=f($)+1;
    r=(x(im1)+x(im2))/2;
  end
endfunction