// Copyright (C) 2002-2008 - DIGITEO - Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function r=weighted_std_deviation(x,n,varargin)
  [lhs,rhs]=argn();
  if rhs<>2 then error("The function ""weighted_std_deviation"" must have two arguments."); end
  if type(x)<>1|find(size(x)==1)==[]|type(n)<>1|find(size(n)==1)==[] then
    error("The arguments of the function ""weighted_std_deviation"" must be vectors of numbers.");
  end
  if size(x,"*")<>size(n,"*") then
    error("The arguments of the function ""weighted_std_deviation"" must be vectors of the same dimension.");
  end
  if min(n)<0 then
    error("The second argument of the function ""weighted_std_deviation"" must be a vector of positive numbers or zeros.");
  end
  if sum(n)<%eps then
    error("The second argument of the function ""weighted_std_deviation"" must not be the null vector.");
  end
  s=sum(n); r=n*(x^2)'/s-((x*n')/s)^2; r=sqrt(r);
endfunction
