// Copyright (C) 2002-2010 - DIGITEO - Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function t=random_subset(n,a_set,varargin)
  [lhs,rhs]=argn();
  if rhs<>2 then error("The function ""random_subset"" must have two arguments."); end
  if type(n)<>1|size(n,"*")<>1|int(n)-n<>0|n<=0 then 
    error("The first argument of the function ""random_subset"" must be a positive integer.");
  end
  if n>size(a_set) then 
    error("The first argument of the function ""random_subset"" may not be greater than the cardinality of the set.");
  end
  if typeof(a_set)<>"a_set" then
    error("The second argument of the function ""random_subset"" must be a set.");
  end
  i=[];
  while size(i,"*")<>n
    i=unique(grand(1,n,"uin",1,size(a_set)));
  end
  v=a_set.elem(i);
  v=gsort(v,"g","i");
  t=mlist(["a_set","elem"],v);
endfunction