// Copyright (C) 2002-2009 - DIGITEO - Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt


function [x,ka,kb]=the_union(a_set1,a_set2,varargin)
  [lhs,rhs]=argn();
  if rhs<2|rhs>3 then 
    error("The function ""the_union"" must have two or three arguments."); 
  end
  if rhs==2&typeof(a_set1)<>"a_set"&typeof(a_set2)<>"a_set" then
    [x,ka,kb]=union_orig(a_set1,a_set2);
  elseif rhs==3&typeof(a_set1)<>"a_set"&typeof(a_set1)<>"ens" then
    orient=varargin(1);
    [x,ka,kb]=union_orig(a_set1,a_set2,orient);
  else
    if rhs<>2 then error("The function ""the_union"" must have two arguments."); end
    if typeof(a_set1)<>"a_set"|typeof(a_set2)<>"a_set" then
      error("The arguments of the function ""the_union"" must have sets.");
    end
    v1=a_set1.elem; v2=a_set2.elem;
    x=set_vector([v1;v2]);
  end
endfunction

function [x,ka,kb]=union_orig(a,b,orient)
// returns the union of  unique components of  vector a and b
// author Serge Steer INRIA
  if argn(2)<3 then
    if argn(1)==1 then
      x=unique([a(:);b(:)])
      x=x';
    else
      kab=[1:size(a,'*'), -(1:size(b,'*'))]
      [x,k]=unique([a(:);b(:)])
      x=x'
      kab=kab(k)
      ka=kab(kab>0)
      kb=-kab(kab<0)
    end
  else
    if  orient==1|orient=="r" then
      if argn(1)==1 then
	x=unique([a;b],'r')
      else
	kab=[1:size(a,'r'), -(1:size(b,'r'))]
	[x,k]=unique([a;b],'r')
	kab=kab(k)
	ka=kab(kab>0)
	kb=-kab(kab<0)
      end  
    elseif orient==2|orient=="c" then
      if argn(1)==1 then
	x=unique([a b],'c')
      else
	kab=[1:size(a,'c'), -(1:size(b,'c'))]
	[x,k]=unique([a b],'c')
	kab=kab(k)
	ka=kab(kab>0)
	kb=-kab(kab<0)
      end  
      
    else
      error(msprintf(gettext("%s: Wrong value for input argument #%d: %d,''%s'',%d or ''%s'' expected\n"),'unique',3,1,"r",2,"c"));
    end
  end
endfunction

